package info.edoardonosotti.android.tutorial.restfulws;

import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.net.URLConnection;

import jondev.Decompress;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;

// This background task will download and unzip content packages
public class DownloadTask extends AsyncTask<String, Void, File> {
	private Handler mHandler;

	public static String RESULT = "RESULT";
	private static String TAG = "DownloadTask";

	public DownloadTask(Handler handler) {
		mHandler = handler;
	}

	@Override
	protected File doInBackground(String... params) {
		try {
			File dest = new File(params[1]);
			File path = new File(dest.getAbsolutePath().substring(0, dest.getAbsolutePath().lastIndexOf(File.separator)));
			
			path.mkdirs();
			if (!path.exists() || !path.isDirectory()) {
				return null;
			}
			
			if (dest.exists()) {
				dest.delete();
			}
			
			URL url = new URL(params[0]);
			URLConnection connection = url.openConnection();
			connection.connect();
			
			InputStream input = new BufferedInputStream(url.openStream());
			OutputStream output = new FileOutputStream(params[1]);

			byte data[] = new byte[1024];
			int count;
			while ((count = input.read(data)) != -1) {
				output.write(data, 0, count);
			}
			
			output.flush();
			output.close();
			input.close();
			
			return dest;
		} catch (Exception e) {
			Log.e(TAG, e.getMessage());
			e.printStackTrace();
			return null;
		}
		
		
	}

	@Override
	protected void onPostExecute(File result) {
		super.onPostExecute(result);
		
		File path = new File(result.getAbsolutePath().substring(0, result.getAbsolutePath().lastIndexOf(File.separator)));
		String subpath = path + "/" + result.getName().substring(0, result.getName().indexOf(".")) + "/";
		
		Decompress d = new Decompress(result.getAbsolutePath(), subpath);
		d.unzip();
		
		if (mHandler != null) {
			Bundle b = new Bundle();
			b.putString(DownloadTask.RESULT, subpath);
			Message m = new Message();
			m.setData(b);
			mHandler.sendMessage(m);
		}
	}

}